Subject: [Netconf] message-id attribute value normalization

From: "Julius Milan -X (jumilan - Pantheon Technologies SRO at Cisco)" <[email-masked]>
Date: Fri, 16 Jan 2015 17:52:33 +0000

Hi all,

I have one detail regarding RFC 6241.
In netconf.xsd is attribute message-id defined as string.
Type string is defined (http://www.schemacentral.com/sc/xsd/t-xsd_string.html) to be non-normalized.
So all whitespace characters (spaces, tabs, carriage returns, and line feeds) must be preserved by the processor.

However in rfc is also written:
"The sender MUST ensure that the "message-id" value is normalized
according to ... if the sender wants the string to be returned unmodified."

Is it intended to have a message-id non-normalized?
Wouldn't be more appropriate to define it as normalizedString (http://www.datypic.com/sc/xsd/t-xsd_normalizedString.html)?
Which is basically the same, just provides normalization of allowed whitespace characters
and as written in specification above:
"This processing is equivalent to the processing of CDATA attribute values in XML 1.0."

Thanks,
Julius

---

From: Andy Bierman <[email-masked]>
Date: Fri, 16 Jan 2015 11:54:19 -0800

On Fri, Jan 16, 2015 at 9:52 AM, Julius Milan -X (jumilan - Pantheon
Technologies SRO at Cisco) <[email-masked]> wrote:
> Type string is defined
> (http://www.schemacentral.com/sc/xsd/t-xsd_string.html) to be
> non-normalized.
>
> So all whitespace characters (spaces, tabs, carriage returns, and line
> feeds) must be preserved by the processor.
>
>
>
> “The sender MUST ensure that the "message-id" value is normalized
>
> according to … if the sender wants the string to be returned unmodified.”
>
>
>
> Wouldn’t be more appropriate to define it as normalizedString
> (http://www.datypic.com/sc/xsd/t-xsd_normalizedString.html)?
>
> “This processing is equivalent to the processing of CDATA attribute values
> in XML 1.0.”
>

The intent is that <rpc-reply> has all the attributes that are in
<rpc> start-tag,
unchanged by the server. The server parses the input parameters and then
returns the attribute encoding of the parsed value in <rpc-reply>.

The server is not supposed to alter these attributes.

It is not clear whether "xmlns" attributes have to be returned unchanged.
A valid XML parser should not rely on specific prefix mappings.

> Julius

Andy

>
> _______________________________________________
> Netconf mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/netconf
>

---

From: "Julius Milan -X (jumilan - Pantheon Technologies SRO at Cisco)" <[email-masked]>
Date: Mon, 19 Jan 2015 09:26:52 +0000

Ok,
But still remains following inconsistency, which could little bit confuse netconf user or developer:

1.) “The sender MUST ensure that the "message-id" value is normalized
according to … if the sender wants the string to be returned unmodified.”

2.) And the fact that message-id should not be normalized according to schema (netconf.xsd).

It's just a detail, but these 2 facts are in conflict.

Regards,
Julius

-----Original Message-----
From: Andy Bierman [mailto:[email-masked]] 
Sent: Friday, January 16, 2015 8:54 PM
To: Julius Milan -X (jumilan - Pantheon Technologies SRO at Cisco)
Cc: [email-masked]; ulfberht-dev(mailer list); Anna Medvedova -X (amedvedo - Pantheon Technologies SRO at Cisco)
Subject: Re: [Netconf] message-id attribute value normalization

On Fri, Jan 16, 2015 at 9:52 AM, Julius Milan -X (jumilan - Pantheon Technologies SRO at Cisco) <[email-masked]> wrote:
> “This processing is equivalent to the processing of CDATA attribute 
> values in XML 1.0.”
>

The intent is that <rpc-reply> has all the attributes that are in <rpc> start-tag, unchanged by the server. The server parses the input parameters and then returns the attribute encoding of the parsed value in <rpc-reply>.

Andy

---

From: Martin Bjorklund <[email-masked]>
Date: Mon, 19 Jan 2015 14:05:36 +0100 (CET)

> It's just a detail, but these 2 facts are in conflict.

I don't think there's a conflict.

Regardless of the XSD, an XML attribute is normalized according to the
rules of XML.

The text basically says that the sender should be aware of this, when
creating the message-id string.

No XSD normalization is involved here.

/martin

---

From: "Ersue, Mehmet (NSN - DE/Munich)" <[email-masked]>
Date: Mon, 19 Jan 2015 13:18:24 +0000

Dear Julius, 

I forwarded your last mail to NETCONF maillist.

Please subscribe to NETCONF maillist if you want to send mails to NETCONF ML.

Please look at NETCONF Wiki for the subscription info:
http://trac.tools.ietf.org/wg/netconf/trac/wiki 

Cheers, 
Mehmet 

-----Original Message-----
From: Julius Milan -X (jumilan - Pantheon Technologies SRO at Cisco) [mailto:[email-masked]] 
Sent: Monday, January 19, 2015 2:11 PM
To: Martin Bjorklund
Cc: [email-masked]; Rastislav Szabo -X (raszabo - Pantheon Technologies SRO at Cisco); Stefan Kobza -X (skobza - Pantheon Technologies SRO at Cisco); [email-masked]; Anna Medvedova -X (amedvedo - Pantheon Technologies SRO at Cisco)
Subject: RE: [Netconf] message-id attribute value normalization

Ok, thanks a lot.

Julius

-----Original Message-----
From: Martin Bjorklund [mailto:[email-masked]] 
Sent: Monday, January 19, 2015 2:06 PM
To: Julius Milan -X (jumilan - Pantheon Technologies SRO at Cisco)
Cc: [email-masked]; Rastislav Szabo -X (raszabo - Pantheon Technologies SRO at Cisco); Stefan Kobza -X (skobza - Pantheon Technologies SRO at Cisco); [email-masked]; Anna Medvedova -X (amedvedo - Pantheon Technologies SRO at Cisco)
Subject: Re: [Netconf] message-id attribute value normalization

Regardless of the XSD, an XML attribute is normalized according to the rules of XML.

The text basically says that the sender should be aware of this, when creating the message-id string.

/martin

---

From: Ladislav Lhotka <[email-masked]>
Date: Mon, 19 Jan 2015 14:48:19 +0100

> On 19 Jan 2015, at 14:18, Ersue, Mehmet (NSN - DE/Munich) <[email-masked]> wrote:
> 
> Dear Julius, 
> 

Of course, an interesting question is how exactly the rules of sec. 3.3.3 in XML spec apply to this case: should leading and trailing spaces be discarded and multiple spaces collapsed to one space?

See also pyang issue #64:

https://code.google.com/p/pyang/issues/detail?id=64

Lada

--
Ladislav Lhotka, CZ.NIC Labs
PGP Key ID: E74E8C0C

---

From: "Julius Milan -X (jumilan - Pantheon Technologies SRO at Cisco)" <[email-masked]>
Date: Mon, 19 Jan 2015 13:10:49 +0000

Ok, thanks a lot.

Julius

-----Original Message-----
From: Martin Bjorklund [mailto:[email-masked]] 
Sent: Monday, January 19, 2015 2:06 PM
To: Julius Milan -X (jumilan - Pantheon Technologies SRO at Cisco)
Cc: [email-masked]; Rastislav Szabo -X (raszabo - Pantheon Technologies SRO at Cisco); Stefan Kobza -X (skobza - Pantheon Technologies SRO at Cisco); [email-masked]; Anna Medvedova -X (amedvedo - Pantheon Technologies SRO at Cisco)
Subject: Re: [Netconf] message-id attribute value normalization

/martin